package de.unihannover.orderingExperimentAnalysis;

import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import static de.unihannover.orderingExperimentAnalysis.SessionData.Defect.putDef;

/**
 * Tutorial
 */
public enum TU implements SessionData.Defect {
    /**
     * Plus is changed with Minus in method sum.
     */
    WRONG_SUM;


    @Override
    public String getShortString() {
        return this.getClass().getSimpleName() + "_" + this.ordinal();
    }

    @Override
    public boolean isDelocalized() {
        return false;
    }


    static Map<String, List<SessionData.Defect>> getTrueDefects() {
        final Map<String, List<SessionData.Defect>> ret = new LinkedHashMap<>();


        /**
         * Pilot
         */
        putDef(ret, "#0L;11;12", SessionData.FP.FP);
        putDef(ret, "#0R;11;123", SessionData.FP.FP);
        putDef(ret, "#0R;12;222", SessionData.FP.FP);

        /**
         * First 10 developers
         */

        putDef(ret, "#0R;12;The operator should be + as the method is to perform addition of 2 numbers", WRONG_SUM);
        putDef(ret, "#0L;0;operation variable is not used.operation should be initialized or make it static", SessionData.FP.FP);
        putDef(ret, "#0L;12;method name should start with small case.", SessionData.FP.FP);
        putDef(ret, "#0R;11;method name should start with small case.", SessionData.FP.FP);
        putDef(ret, "#0R;12;there should be sum operation as per method name implies", WRONG_SUM);
        putDef(ret, "#0R;12;Incurrect operation - need to change it to +", WRONG_SUM);
        putDef(ret, "#0R;12;Naming convention and purpose of the operation is required", SessionData.FP.FP);
        putDef(ret, "#0R;12;int sum = first + second;", WRONG_SUM);
        putDef(ret, "#0R;0;Should be have class name like public class MathOperation {  }", SessionData.FP.FP);
        putDef(ret, "#0R;12;To sum of two numbers, must use + operator", WRONG_SUM);
        putDef(ret, "#0R;13;We can direct return the result like return first + second;", SessionData.FP.FP);
        putDef(ret, "#0L;0;Operation variable name shoub be initialized or should be static because then it will take default value", SessionData.FP.FP);
        putDef(ret, "#0L;11;method name should start with lowercase and operation performed method that should implies as method name", SessionData.FP.FP);
        putDef(ret, "#0R;12;first result will show addition then subtrcation", WRONG_SUM);

        /**
         * E - first 30 developers (second batch for inter-rater agreement)

        putDef(ret, "#0R;0;this variable should be used but its not used in the program", SessionData.FP.FP);
        putDef(ret, "#0R;12;as the method implies the addition operation but it performs the subtraction operation.so this method should perfom addition operation", WRONG_SUM);
        putDef(ret, "#0L;2;method name should follow naming convention rule", SessionData.FP.FP);
        putDef(ret, "#0R;12;Wrong operation. should be addition sign", WRONG_SUM);
        putDef(ret, "#0R;0;declartion is outside", SessionData.FP.FP);
        putDef(ret, "#0R;12;The method says to add two integers not to subtract", WRONG_SUM);
        putDef(ret, "#0R;0;this variable should be used but its not used in the program or make it static", SessionData.FP.FP);
        putDef(ret, "#0R;11;as the method implies the addition operation but it performs the subtraction operation.so this method should perfom addition operation", WRONG_SUM);
        putDef(ret, "#0R;12;This code change the actual meaning of method which is suppose to add two integer values", WRONG_SUM);
        putDef(ret, "#0R;12;there should be '+' operator", WRONG_SUM);
        putDef(ret, "#0R;8;return operation;", SessionData.FP.FP);
        putDef(ret, "#0R;12;+ needed for sum operation", WRONG_SUM);
        putDef(ret, "#0R;12;This will perform substraction operation and sum variable will hold subtracted value not the sum of two values.", WRONG_SUM);
        putDef(ret, "#0R;12;infinite loop", SessionData.FP.FP);

         E - third batch of developers for inter-rater agreement

        putDef(ret, "#0R;0;this variable is not used", SessionData.FP.FP);
        putDef(ret, "#0R;11;its recommended to take the method name as it performs the operation.but here the method name should be as per the operation its performing", WRONG_SUM);
        putDef(ret, "#0R;12;variable name should not be sum it should be according to the operation", SessionData.FP.FP);
        putDef(ret, "#0L;11;we removed one extra blank line between two methods.", SessionData.FP.FP);
        putDef(ret, "#0L;13;we are performing addition on two number but in new version code we can see subtract sign between two number.", WRONG_SUM);
        putDef(ret, "#0L;13;directly return the result", SessionData.FP.FP);
        putDef(ret, "#0R;12;Why adding integers became substraction?", WRONG_SUM);
        putDef(ret, "#0R;13;instead of returning sum, directly first - second can be returned.", SessionData.FP.FP);
        putDef(ret, "#0R;11;output of the program will differ from the old one due to subtraction operation performed insted of addition", WRONG_SUM);
        putDef(ret, "#0L;11;main method missing", SessionData.FP.FP);
        putDef(ret, "#0L;11;\"-\" sign should be replace by \"+\"", WRONG_SUM);
        putDef(ret, "#0R;11;If operation has changed method name should also change according to the performed operation", SessionData.FP.FP);
        putDef(ret, "#0R;12;The operation must be the as mentioned by the method name", WRONG_SUM);
        putDef(ret, "#0R;12;For sum of two integer here used \"-\" substraction sign, please changes to \"+\" for adition. instead of creating \"int sum\" you can directly use like \"return first + second;\"", WRONG_SUM);

        putDef(ret, "#0R;12;added correct operator", WRONG_SUM);
        putDef(ret, "#0R;12;binary operator is wrong", WRONG_SUM);
        putDef(ret, "#0R;2;No need to specify access specifier", SessionData.FP.FP);
        putDef(ret, "#0R;10;need + operator for addition", WRONG_SUM);
        putDef(ret, "#0R;11;remove blank line", SessionData.FP.FP);
        putDef(ret, "#0R;12;Method name suggest sum of two integers change method name accordinglt", WRONG_SUM);
        */




        /**
         * Final version - first 30 developers
         */

        putDef(ret, "#0R;0;this variable should be used but its not used in the program", SessionData.FP.FP);
        putDef(ret, "#0R;12;as the method implies the addition operation but it performs the subtraction operation.so this method should perfom addition operation", WRONG_SUM);
        putDef(ret, "#0L;2;method name should follow naming convention rule", SessionData.FP.FP);
        putDef(ret, "#0R;12;Wrong operation. should be addition sign", WRONG_SUM);
        putDef(ret, "#0R;0;declartion is outside", SessionData.FP.FP);
        putDef(ret, "#0R;12;The method says to add two integers not to subtract", WRONG_SUM);
        putDef(ret, "#0R;0;this variable should be used but its not used in the program or make it static", SessionData.FP.FP);
        putDef(ret, "#0R;11;as the method implies the addition operation but it performs the subtraction operation.so this method should perfom addition operation", WRONG_SUM);
        putDef(ret, "#0R;12;This code change the actual meaning of method which is suppose to add two integer values", WRONG_SUM);
        putDef(ret, "#0R;12;there should be '+' operator", WRONG_SUM);
        putDef(ret, "#0R;8;return operation;", SessionData.FP.FP);
        putDef(ret, "#0R;12;+ needed for sum operation", WRONG_SUM);
        putDef(ret, "#0R;12;This will perform substraction operation and sum variable will hold subtracted value not the sum of two values.", WRONG_SUM);
        putDef(ret, "#0R;12;infinite loop", SessionData.FP.FP);

        /**
         * Final version - second 30 developers
         */

        putDef(ret, "#0R;0;this variable is not used", SessionData.FP.FP);
        putDef(ret, "#0R;11;its recommended to take the method name as it performs the operation.but here the method name should be as per the operation its performing", WRONG_SUM);
        putDef(ret, "#0R;12;variable name should not be sum it should be according to the operation", WRONG_SUM);
        putDef(ret, "#0L;11;we removed one extra blank line between two methods.", SessionData.FP.FP);
        putDef(ret, "#0L;13;we are performing addition on two number but in new version code we can see subtract sign between two number.", WRONG_SUM);
        putDef(ret, "#0L;13;directly return the result", SessionData.FP.FP);
        putDef(ret, "#0R;12;Why adding integers became substraction?", WRONG_SUM);
        putDef(ret, "#0R;13;instead of returning sum, directly first - second can be returned.", SessionData.FP.FP);
        putDef(ret, "#0R;11;output of the program will differ from the old one due to subtraction operation performed insted of addition", WRONG_SUM);
        putDef(ret, "#0L;11;main method missing", SessionData.FP.FP);
        putDef(ret, "#0L;11;\"-\" sign should be replace by \"+\"", WRONG_SUM);
        putDef(ret, "#0R;11;If operation has changed method name should also change according to the performed operation", WRONG_SUM);
        putDef(ret, "#0R;12;The operation must be the as mentioned by the method name", WRONG_SUM);
        putDef(ret, "#0R;12;For sum of two integer here used \"-\" substraction sign, please changes to \"+\" for adition. instead of creating \"int sum\" you can directly use like \"return first + second;\"", WRONG_SUM);

        putDef(ret, "#0R;12;added correct operator", WRONG_SUM);
        putDef(ret, "#0R;12;binary operator is wrong", WRONG_SUM);
        putDef(ret, "#0R;2;No need to specify access specifier", SessionData.FP.FP);
        putDef(ret, "#0R;10;need + operator for addition", WRONG_SUM);
        putDef(ret, "#0R;11;remove blank line", SessionData.FP.FP);
        putDef(ret, "#0R;12;Method name suggest sum of two integers change method name accordinglt", WRONG_SUM);

        /*
        E - second 30 developers
         */

        putDef(ret, "#0R;12;use + oprator instead of  - operator", WRONG_SUM);
        putDef(ret, "#0R;0;This veriable not use", SessionData.FP.FP);
        putDef(ret, "#0R;11;method name should be according to the operation it performs.", WRONG_SUM);
        putDef(ret, "#0R;12;varibale name should be sub according to the result stored in it", WRONG_SUM);
        putDef(ret, "#0R;0;This variable is not used anywhere in code.", SessionData.FP.FP);
        putDef(ret, "#0R;11;Method name should be according to the operation it performs. It should be subTwoIntegers", WRONG_SUM);
        putDef(ret, "#0R;13;Varibale name should be sub according to the result stored in it and it should be intialised", WRONG_SUM);
        putDef(ret, "#0L;11;Line space in new code is identified, before comitting the code to the  repo cod eshuld be aliggned properly should take care of line spaces.", SessionData.FP.FP);
        putDef(ret, "#0L;13;In new code changes logical error is corrected, sum includes '+' operator", WRONG_SUM);
        putDef(ret, "#0R;11;Line space change", SessionData.FP.FP);
        putDef(ret, "#0R;12;It will perform subraction operation but the method is 'sum()'.", WRONG_SUM);
        putDef(ret, "#0R;12;Doing wrong operation", WRONG_SUM);
        putDef(ret, "#0R;12;there should be + sign in sum", WRONG_SUM);
        putDef(ret, "#0R;0;method name should be according to the operation it performs.", WRONG_SUM);
        putDef(ret, "#0R;11;Method name is sum and internally it is doing subtraction change method name and also variable name to proper convention", WRONG_SUM);
        putDef(ret, "#0R;0;Variabe is o used in proram", SessionData.FP.FP);
        putDef(ret, "#0R;11;Method name should be acording to the operation it performs", WRONG_SUM);
        putDef(ret, "#0R;12;variable name should be sub according to the result stored it and return type should be double", WRONG_SUM);
        putDef(ret, "#0R;12;there should be plus operator instaed of minus.", WRONG_SUM);
        putDef(ret, "#0R;12;there should be  + operator insted of -", WRONG_SUM);
        putDef(ret, "#0R;12;Here sum of primitive int (integers) should be done with ' + ' operator", WRONG_SUM);
        putDef(ret, "#0R;11;The main purpose of this method is change if we change the operation .", WRONG_SUM);
        putDef(ret, "#0R;12;There sholud be + sign, beacuse method name is sumTwoIntegers. Or if requirment is substraction then need to change method name as substractionTwoIntegers.", WRONG_SUM);
        putDef(ret, "#0R;5;extra line", SessionData.FP.FP);
        putDef(ret, "#0R;11;method name Should be subTwoIntegers", WRONG_SUM);
        putDef(ret, "#0R;13;not need extra varible sum like  return first-second;", SessionData.FP.FP);
        putDef(ret, "#0R;5;remove extra line", SessionData.FP.FP);


 /*
        P - second 30 developers
         */

        putDef(ret, "#0R;10;Extra line removed", SessionData.FP.FP);
        putDef(ret, "#0R;12;If the method name says to sum two integers than addition (+) operator should be used.", WRONG_SUM);
        putDef(ret, "#0R;12;THE ADDITION SIGN BETWEEN FIRST AND SECOND NUMBER GOT REPLACED TO SUBTRACTION SIGN CONTRADICTING THE METHOD NAME sumTwoIntegers", WRONG_SUM);
        putDef(ret, "#0L;11;Unwanted extra lines", SessionData.FP.FP);
        putDef(ret, "#0L;13;Method Name and functional operation is different, Unnecessary variable assignment sum, instead return directly.", WRONG_SUM);
        putDef(ret, "#0L;14;Directly return instead of assignig to sum variable", SessionData.FP.FP);
        putDef(ret, "#0R;12;here use '+' operator instead of '-'", WRONG_SUM);
        putDef(ret, "#0R;0;variable is not used in program", SessionData.FP.FP);
        putDef(ret, "#0R;11;Operation should be as per method name", WRONG_SUM);
        putDef(ret, "#0R;10;deleted whitespace", SessionData.FP.FP);
        putDef(ret, "#0R;11;deleted whitespace", SessionData.FP.FP);
        putDef(ret, "#0R;12;changed operator", WRONG_SUM);
        putDef(ret, "#0R;12;it should be addition sign in sumTwoInteger method", WRONG_SUM);
        putDef(ret, "#0R;12;it should be first+second as the method indicates sum of two values", WRONG_SUM);
        putDef(ret, "#0R;12;must be plus operator", WRONG_SUM);
        putDef(ret, "#0R;11;arthematic operator should be +", WRONG_SUM);
        putDef(ret, "#0R;11;function belings to addition", WRONG_SUM);
        putDef(ret, "#0R;12;used operarator is wrong", WRONG_SUM);
        putDef(ret, "#0R;11;this functions is for sum of two integer", WRONG_SUM);
        putDef(ret, "#0R;12;Need to sum of two numbers", WRONG_SUM);
        putDef(ret, "#0R;12;here it is recommended to put + sign", WRONG_SUM);
        putDef(ret, "#0R;12;Here you can given + in the b/w first in second", WRONG_SUM);

        return ret;
    }
}
