package de.unihannover.orderingExperimentAnalysis;

import static de.unihannover.orderingExperimentAnalysis.SessionData.Defect.putDef;

import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;

import de.unihannover.orderingExperimentAnalysis.SessionData.Defect;
import de.unihannover.orderingExperimentAnalysis.SessionData.FP;

public enum WU implements Defect {
    /**
     * From and to swapped in method call.
     */
    FROM_TO_SWAP,
    /**
     * Inconsistent check of from index, upper bound is checked as zero-based but lower-bound is checked as one-based.
     */
    OFF_BY_ONE1,
    /**
     * Inconsistent check of to index, upper bound is checked as zero-based but lower-bound is checked as one-based.
     */
    OFF_BY_ONE2;

    @Override
    public String getShortString() {
        return this.getClass().getSimpleName() + "_" + this.ordinal();
    }

    @Override
    public boolean isDelocalized() {
        return this == FROM_TO_SWAP;
    }


    static Map<String, List<Defect>> getTrueDefects() {
        final Map<String, List<Defect>> ret = new LinkedHashMap<>();

        //First group of developers - pilot study
        
        putDef(ret, "#0R;68;reordering is allowed", FP.FP); 
        putDef(ret, "#1R;275;added new implementation for columnMoved() and you need keep old implementation with this you can achieve static polymorphism", FP.FP); 
        putDef(ret, "#2R;581;sequence of the parameter of columnMoved() is wrong", WU.FROM_TO_SWAP);
        putDef(ret, "#0R;68;recording allowed", FP.FP); 
        putDef(ret, "#1R;275;Added protected method columnMoved() and its implementation", FP.FP);
        putDef(ret, "#2R;581;Added implementation to public columnMoved()", FP.FP);
        putDef(ret, "#1R;285;will go in infinite loop", WU.OFF_BY_ONE2);
        putDef(ret, "#2R;581;with the help of this method get index", WU.FROM_TO_SWAP);
        putDef(ret, "#1R;275;wrong parsing of parameters that is passing getToIndex and getFromIndex but recieving from and then to", WU.FROM_TO_SWAP);
        putDef(ret, "#1R;285;will go in infinite loop as extendedAttr trying to get value from extAttrs and extAttrs waiting for value from extendedAttr", FP.FP);
        putDef(ret, "#0R;68;setReorderingAllowed(true)  maked it true", FP.FP);
        putDef(ret, "#2R;580;columnMoved(TableColumnModelEvent e) metthod is ovveride to move column", FP.FP);
        putDef(ret, "#2R;581;columnMoved() method called but parameter  passed in reverse form", WU.FROM_TO_SWAP);
        putDef(ret, "#0R;68;This is correct, after rendering data will set re ordering for all table headers", FP.FP);
        putDef(ret, "#1R;275;insted of if clause , we can use ternary operator", FP.FP);
        putDef(ret, "#2R;580;it is perfect, no issue, because ,whenever the column will be moved then will set [To & From] Index to VFSDirectoryEntryTableModel", FP.FP);
        putDef(ret, "#2R;581;The parameter of columnMoved() should be in same order that mension above.", WU.FROM_TO_SWAP); 
        putDef(ret, "#2R;580;Add new implementation for columnMoved() & you need to keep old implementation as well.", FP.FP); 
        putDef(ret, "#1R;285;column move is expected to move only one column where as multiple line can be done", FP.FP); //?
        putDef(ret, "#2R;581;Explicit typecasting is not the preffered way of coding it should always check  , instanceof before typecasting", FP.FP); 
        putDef(ret, "#0R;68;When the column parameter is out of bounds this method uses the same conventions as the JTable", FP.FP); 
        putDef(ret, "#1R;276;Line 276 to 284 can be written using ternary operator", FP.FP); 
        putDef(ret, "#2R;581; The  parameter  swap  inthe call of ‘columnMoved’ is a delocalized defect because both the second andthird change part have to be combined to find it.", WU.FROM_TO_SWAP); 
        putDef(ret, "#2R;581;mismatch of the parameters send to columnMoved() in VFSDirectoryEntryTableModel.java", WU.FROM_TO_SWAP); 
        putDef(ret, "#0R;68;Okay, With Set Reorder Method , we re-define the all header columns width equal", FP.FP); 
        
        
        //Second group of developers remarks - pilot study
        
        
        putDef(ret, "#0R;58;VFSDirectoryEntryTable must be extending JTable", FP.FP); 
        putDef(ret, "#0R;59;What is need to pass \"new VFSDirectoryEntryTableModel()\" to super class", FP.FP);
        putDef(ret, "#0R;64;renderer should be object of FileCellRenderer", FP.FP);
        putDef(ret, "#0R;65;setDefaultRenderer(Entry.class, new FileCellRenderer()););", FP.FP);
        putDef(ret, "#0R;67;header should be object of JTableHeader", FP.FP);
        putDef(ret, "#0R;68;If setReorderingAllowed is true then is it used somewhere?", FP.FP);
        putDef(ret, "#2R;581;Variable passed are miss-placed. It should be ((VFSDirectoryEntryTableModel)getModel()).columnMoved( e.getFromIndex(),e.getToIndex());", WU.FROM_TO_SWAP);
        putDef(ret, "#0R;58;VFSDirectoryEntryTable  shoud be extends Jtable", FP.FP);
        putDef(ret, "#0R;59;we passed here ,new VFSDirectoryEntryTableModel() object inside super keyword which is used to call super class contructor", FP.FP);
        putDef(ret, "#0R;60;browserView is instance variable to globalise that this keyword used here", FP.FP);
        putDef(ret, "#0R;64;assuming private final FileSaleRenderer rendrer;", FP.FP);
        putDef(ret, "#0R;67;assuming private final JtableHeader header;", FP.FP);
        putDef(ret, "#0R;68;header.setReorderingAllowed(true) this method belongs to JtableHeader class we have passed true here for to set reording", FP.FP);
        putDef(ret, "#0R;69;assumed MainMouseHandler class which will extends MouseInputAdapter and override its mousePressed event", FP.FP);
        putDef(ret, "#0R;70;assumed MouseHandler class which will extends MouseInputAdapter and override its mouseClicked event", FP.FP);
        putDef(ret, "#1R;275;receiving parameters in wrong pattern we  are passing to index and from index and recieving from an to", WU.FROM_TO_SWAP);
        putDef(ret, "#0R;58;class should extends JTable as we are using setDefaultRenderer of JTable", FP.FP);
        putDef(ret, "#0R;59;here parent class of VFSDirectoryEntryTable class is JTable and we are passing object of VFSDirectoryEntryTableModel in super but its parent class JTable does not hold constructor for respective which can cause conflict", FP.FP);
        putDef(ret, "#0R;64;assuming 	private final FileCellRenderer renderer; is created at class level", FP.FP);
        putDef(ret, "#0R;65;here we can reduce coding by adding code like setDefaultRenderer(Entry.class,renderer = new FileCellRenderer());", FP.FP);
        putDef(ret, "#0R;67;assuming private final JTableHeader header; is created at class level", FP.FP);
        putDef(ret, "#1R;275;receiving parameters in wrong pattern that is we are passing toIndex and fromIndex but here receiving from and to which will impact further code logic", WU.FROM_TO_SWAP);
        putDef(ret, "#1R;277;Return statement should be meaningfull.It should return some value and data.", FP.FP);
        putDef(ret, "#0R;74;Review: Method invocation should not be allowed without the use of proper object.", FP.FP);
        putDef(ret, "#0R;78;Review: Method invocation should not be allowed without the use of proper object.", FP.FP);
        putDef(ret, "#1R;275;naming convention isn't proper as per the method definition in method columnMoved.", WU.FROM_TO_SWAP);
        putDef(ret, "#1R;276;Rather than writing the if ladder, we can use for loop.", FP.FP);
        putDef(ret, "#1R;277;If we are returning something then method should retrun some value. Or it may lead to recursive call.", FP.FP);
        putDef(ret, "#1R;275;Parmeter provided for this method colmun moved, will create issue by naming convention and if new developer want's to work in future, he might confused to update the logic.", WU.FROM_TO_SWAP);
        putDef(ret, "#0R;74;Method need to invoked using specific objet.", FP.FP);
        putDef(ret, "#0R;78;Method need to invoked using specific objet.", FP.FP);
        putDef(ret, "#1R;275;Method parameter sequence should be proper .", WU.FROM_TO_SWAP);
        putDef(ret, "#0R;68;while creating header objet, you can set setReorderingAllowed(true); inside the getTableHeader() method", FP.FP);
        putDef(ret, "#1R;279;using ternary operator , you can reduce the code", FP.FP);
        putDef(ret, "#2R;581;no issue found", FP.FP);
        putDef(ret, "#0R;68;it is good practice to set property while create / initialize object, so while creating header object of table using \"getTableHeader\" function, there you can set setReorderingAllowed(true) property", FP.FP);
        putDef(ret, "#1R;280;using ternary operator  , you can reduce the code", FP.FP);
        putDef(ret, "#0R;68;We could have passed this boolean value for rendering allowed property in getHeaders method", FP.FP); 
        putDef(ret, "#1R;281;We could have used ternary operator or if else statement", FP.FP); 
        putDef(ret, "#2R;581;No such issue or improvement found", FP.FP); 
        putDef(ret, "#2R;581;Explicit casting without checking if its instance of", FP.FP);
        
        
        //Third group of developers - pilot study
        
        putDef(ret, "#0R;68;while creating a instance of Table Header, you set the header property inside the constructor", FP.FP); 
        putDef(ret, "#1R;281;not getting clear idea", FP.FP); // :(
        putDef(ret, "#2R;582;no issue", FP.FP); // :/
        putDef(ret, "#1R;275;Method is toatally about stopping end-user passsing an illegal arguments by giving an contraints. So here istead of making an abnormal termination, better to use any of exception class or show an traceMessage to enduser.", FP.FP); 
        putDef(ret, "#1R;276;And should not be written this coditions in multiple lines. Best practice of code writing is nothing but compressing the code as much as we can.", FP.FP); 
        putDef(ret, "#1R;277;For instance : if(from == to || from > 1 || from >= getColummnCount() || to < 1 || to >= getColumnCount()){return;}    ... This is just because all conditons were returning same or trying to make an abnormal termination of method.", FP.FP); 
        putDef(ret, "#1R;277;return statement should be meaningfull.Should return atleast null.", FP.FP); 
        putDef(ret, "#2R;582;Passing value to that method (columnMoved()) parameter should be in order.", WU.FROM_TO_SWAP); 
        putDef(ret, "#0R;74;Can not invoke method without object.", FP.FP); 
        putDef(ret, "#0R;78;Can not invoked method without object.", FP.FP); 
        putDef(ret, "#2R;574;saveWidths() method not implemented in this class", FP.FP); 
        putDef(ret, "#0R;78;To make it reactive autoResize should be enabled", FP.FP); 
        putDef(ret, "#1R;276;line 276, 279 and 282 all conditions can be checked at once in single if", FP.FP); 
        putDef(ret, "#2R;574;If object is not needed then class can be made abstract as all methods are not implemented", FP.FP); 
        putDef(ret, "#2R;582;misplaced \"from\" and \"to\" parameters", WU.FROM_TO_SWAP); 
        putDef(ret, "#1R;276;line 276, 279 and 282 all conditions can be checked at once", FP.FP); 
        putDef(ret, "#0R;78;To make the UI reactive make setAutoResizeMode(AUTO_RESIZE_ON)", FP.FP); 
        putDef(ret, "#1R;276;all the 3 if conditions can be wrapped up in one single condition separated by or operator.", FP.FP); 
        putDef(ret, "#2R;574;If object is not needed it can be abstract as all methods are not implemented.", FP.FP); 
        putDef(ret, "#2R;581;Can lead to ClassCastException.", FP.FP); 
        putDef(ret, "#0R;74;Method can't be invoked without the use of object.", FP.FP); 
        putDef(ret, "#0R;78;method can't be invoked without object", FP.FP); 
        putDef(ret, "#2R;581;The sequence of the parameters passed to the method columnMoved() should be correct.", WU.FROM_TO_SWAP); 
        putDef(ret, "#2R;581;Before casting we should use instanceof checker.", FP.FP); 
        putDef(ret, "#0R;68;This is wrong , by default it will true, so no need to setReordering property true", FP.FP); 
        putDef(ret, "#1R;281;we can use ternary operator and can reduce the code", FP.FP); 
        putDef(ret, "#2R;582;no error found", FP.FP); 




        /**
         * Internal Pilot study
         */
        putDef(ret, "#2R;279;it should be allowed to move from getColumnCount(). so change the check to \"from > getColumnCount()\"", WU.OFF_BY_ONE1);
        putDef(ret, "#2R;282;it should be allowed to move to getColumnCount(). so change the check to \"to > getColumnCount()\"", WU.OFF_BY_ONE2);
        putDef(ret, "#0R;70;I guess header is a global variable", FP.FP);
        putDef(ret, "#2R;279;does the count start at 1 not at 0? If so then the >= should be only >, if it starts at 0 than you should replace 1 by 0", WU.OFF_BY_ONE1);
        putDef(ret, "#2R;282;does the count start at 1 not at 0? If so then the >= should be only >, if it starts at 0 than you should replace 1 by 0", WU.OFF_BY_ONE2);
        putDef(ret, "#2R;285;please include some comment explaining why this is necessary", FP.FP);
        putDef(ret, "#2R;286;what is extAttrs? I cannot show more context in this file, is it a global variable?", FP.FP);
        putDef(ret, "#1R;582;from and to should be inverted", WU.FROM_TO_SWAP);
        putDef(ret, "#2R;279;Seems to be impossible to put and column at the end of the table cause to == getColumnCount should be a reliable condition", WU.OFF_BY_ONE1);
        putDef(ret, "#2R;282;Seems to be impossible to put and column at the end of the table cause to == getColumnCount should be a reliable condition", WU.OFF_BY_ONE2);
        putDef(ret, "#2R;285;Seems to be impossible to put and column at the end of the table cause to == getColumnCount should be a reliable condition", FP.FP);
        putDef(ret, "#2R;286;Seems to be impossible to put and column at the end of the table cause to == getColumnCount should be a reliable condition", FP.FP);


        /**
         * first 10 developers
         */

        putDef(ret, "#0R;59;super(VFSDirectoryEntryTableModel())", FP.FP);
        putDef(ret, "#0R;61;browserView.setShowGrid(false);", FP.FP);
        putDef(ret, "#0R;65;browserView.setDefaultRenderer(Entry.class,renderer)", FP.FP);
        putDef(ret, "#0R;74;header.setRowSelectionAllowed(true);", FP.FP);
        putDef(ret, "#0R;76;header.getColumnModel().addColumnModelListener(new ColumnHandler());", FP.FP);
        putDef(ret, "#0R;78;header.setAutoResizeMode(AUTO_RESIZE_OFF);", FP.FP);
        putDef(ret, "#1R;581;((VFSDirectoryEntryTableModel)getModel()).columnMoved(e.getFromIndex(), e.getToIndex());", WU.FROM_TO_SWAP);
        putDef(ret, "#2R;286;extAttrs.add(extendedAttr , to-1);", FP.FP);
        putDef(ret, "#2R;276;need to mention same dimentions", FP.FP);
        putDef(ret, "#2R;277;Return Statement not required", FP.FP);
        putDef(ret, "#2R;279;need to set updated coorinates to move", FP.FP);
        putDef(ret, "#2R;280;Return statement not required", FP.FP);
        putDef(ret, "#2R;282;need to set currect coordinates to move", FP.FP);
        putDef(ret, "#2R;283;return stsatement not requred", FP.FP);
        putDef(ret, "#0R;63;browserView.setIntercellSpacing(new Dimension(0,0));", FP.FP);
        putDef(ret, "#0R;68;browserView.setDefaultRenderer(Entry.class, renderer);", FP.FP);
        putDef(ret, "#0R;74;browserView.setRowSelectionAllowed(true);", FP.FP);
        putDef(ret, "#0R;78;browserView.setAutoResizeMode(AUTO_RESIZE_OFF);", FP.FP);
        putDef(ret, "#2R;286;extAttrs.add(extendedAttr, to - 1 );", FP.FP);
        putDef(ret, "#1R;580;No needed", FP.FP);
        putDef(ret, "#1R;582;We can not pass function in a another function as a arguments", FP.FP);
        putDef(ret, "#0R;63;browser.setIntercellSpacing(new Dimension(0,0));", FP.FP);
        putDef(ret, "#0R;65;browser.setDefaultRenderer(Entry.class, renderer);", FP.FP);
        putDef(ret, "#0R;74;browser.setRowSelectionAllowed(true);", FP.FP);
        putDef(ret, "#0R;78;browser.setAutoResizeMode(AUTO_RESIZE_OFF);", FP.FP);
        putDef(ret, "#2R;286;extAttrs.add(extendedAttr, to - 1);", FP.FP);

        /**
         * E - first 30 developers (second batch for inter-rater agreement)


        putDef(ret, "#1R;588;this method is not define in this programm", FP.FP);
        putDef(ret, "#2R;279;we can use here else if condition", FP.FP);
        putDef(ret, "#2R;282;we can put this code in else block", FP.FP);
        putDef(ret, "#2R;277;nothing has been returned here", FP.FP);
        putDef(ret, "#2R;280;nothing has been returned here", FP.FP);
        putDef(ret, "#2R;283;nothing has been returned here", FP.FP);
        putDef(ret, "#2R;286;ColomnMoved should return ExtendedAttribute", FP.FP);
        putDef(ret, "#1R;588;this method is defined in the program", FP.FP);
        putDef(ret, "#2R;279;we can provide else block there in stead of if", FP.FP);
        putDef(ret, "#2R;276;all if statements uses just return", FP.FP);
        putDef(ret, "#1R;581;Instead of unnecessary casting you can write protected method and return same", FP.FP);
        putDef(ret, "#2R;275;no need to add any code in model", FP.FP);
        putDef(ret, "#1R;588;this method is not defined in class", FP.FP);
        putDef(ret, "#2R;279;we can use else if loop here", FP.FP);
        putDef(ret, "#2R;282;we can put this code into else", FP.FP);

        putDef(ret, "#0R;68;making false to true make changes in Re-ordering of header on UI", FP.FP);
        putDef(ret, "#1R;580;columnMoved method should be preoperly use to get the benefit of inheritance concept", FP.FP);
        putDef(ret, "#2R;275;method should not be protected due to basic rule of inheritance of protected", FP.FP);
        putDef(ret, "#2R;277;return type should not be there due to void", FP.FP);

        putDef(ret, "#1R;588;This method is not defind in this program", FP.FP);
        putDef(ret, "#2R;279;We can use here else condition after if", FP.FP);
        putDef(ret, "#2R;282;We can put this code in else condition", FP.FP);
        putDef(ret, "#1R;582;columnMoved(e.getFromIndex(), e.getToIndex())", WU.FROM_TO_SWAP);
        putDef(ret, "#0R;64;FileCellRenderer renderer = new FileCellRenderer();", FP.FP);
        putDef(ret, "#0R;65;browserView.setDefaultRenderer(Entry.class, renderer);", FP.FP);
        putDef(ret, "#1R;581;((VFSDirectoryEntryTableModel)getModel()).columnMoved( e.getFromIndex(),e.getToIndex());", WU.FROM_TO_SWAP);

         third batch for inter-rater agreement

        putDef(ret, "#1R;576;this.e = e", FP.FP);
        putDef(ret, "#0R;68;Correct", FP.FP);
        putDef(ret, "#1R;582;it  should be e.getFromIndex(), e.getToIndex());", WU.FROM_TO_SWAP);
        putDef(ret, "#2R;282;if (to<1 || to<=getColumnCount(){", FP.FP);
        putDef(ret, "#2R;284;if (to<from){return;}", FP.FP);
        putDef(ret, "#2R;279;instead of taking seperate if condition we cn take else block to meet the requirment", FP.FP);
        putDef(ret, "#0L;61;allow grid view in file system browser. we can pass parameter as true in setShowGrid.", FP.FP);
        putDef(ret, "#0L;78;we can set AUTO_RESIZE_ON as default , using this predefined variable we not need to resize manually.", FP.FP);
        putDef(ret, "#1L;576;we will store column count in on variable / we can use getColumnCount method than add 1 number / or we can apply increment on \"to\" variable. as \"to\" variable have max column count .", FP.FP);
        putDef(ret, "#1L;578;we can remove one column using getColumnCount() like we can subtract 1 no from  \"to\" variable. as \"to\" variable have max column count for table", FP.FP);
        putDef(ret, "#2R;279;conditions could be combined", FP.FP);

        putDef(ret, "#2R;282;to value should start from 2 and ends at getcolumnCount(). So = should be removed from the condition.", WU.OFF_BY_ONE2);
        putDef(ret, "#1R;581;Arguments passed to columnMoved method are mismatched with the method signature. Hence it may lead to inconsistent output.", WU.FROM_TO_SWAP);
        putDef(ret, "#0L;68;that is correct", FP.FP);
        putDef(ret, "#1L;580;its  correct", FP.FP);
        putDef(ret, "#0L;68;make this true", FP.FP);
        putDef(ret, "#1L;580;get index", FP.FP);
        putDef(ret, "#0R;68;Header object is not able to recognized", FP.FP);
        putDef(ret, "#2R;279;We can use else block instead of if block", FP.FP);
        putDef(ret, "#0R;58;the browserView is not the correct argument of this constructor as this is not used after initialize", FP.FP);
        putDef(ret, "#0R;59;Super() is used for calling parent constructor only.", FP.FP);
        putDef(ret, "#0R;62;if this class has the purpose to protect the data then all methods are should declare in Abstarct class and this constructor should not have all funcationality , Constructor only used for initialize the variables and obj creation. and method body should be declare in implemented class for secure purpose.", FP.FP);
        putDef(ret, "#1R;581;Here need to inter changed the parameter for columnMoved(from,to) method based on method body and its declaration. 2. Here need to create a object of VFSDirectoryEntryTableModel to call getModel() because this is getter method and this cant be called via use of classtype.", WU.FROM_TO_SWAP);
        putDef(ret, "#2R;277;1. method has return type void then if condition can't return. for this we can throw approperiate error-message/exception.", FP.FP);
        putDef(ret, "#2R;279;please don't use {..} for single line if condition", FP.FP);
        putDef(ret, "#2R;282;we can use all if condition in a single if condition, its better with less line of code", FP.FP);


        putDef(ret, "#1R;581;Here need to inter changed the parameter for columnMoved(from,to) method based on method body and its declaration.", WU.FROM_TO_SWAP);
        putDef(ret, "#1R;574;must overrride methods from implemented interface or must be marker or have some default method", FP.FP);
        putDef(ret, "#1R;576;Need statements", FP.FP);
        putDef(ret, "#1R;578;Need statements", FP.FP);
        putDef(ret, "#1R;581;should check with syntax to call method", WU.FROM_TO_SWAP); //to discuss
        putDef(ret, "#1R;585;Need statements", FP.FP);
        putDef(ret, "#1R;587;No need to pass argument not using it", FP.FP);
        putDef(ret, "#2R;275;No Exception handled here", FP.FP);
        putDef(ret, "#2R;282;we can check all statement in one condition", FP.FP);
        putDef(ret, "#0R;68;.", FP.FP);
        putDef(ret, "#1R;581;para constructor", FP.FP); //to discuss
        putDef(ret, "#2R;281;no Idea", FP.FP);

        putDef(ret, "#0R;68;add line", FP.FP);
        putDef(ret, "#1R;580;changes in code", FP.FP);
        putDef(ret, "#2R;279;add new code", FP.FP);
        putDef(ret, "#1R;580;this method is never used", FP.FP);
         */

        /**
         * Final version - first 30 developers
         */

        putDef(ret, "#1R;588;this method is not define in this programm", FP.FP);
        putDef(ret, "#2R;279;we can use here else if condition", FP.FP);
        putDef(ret, "#2R;282;we can put this code in else block", FP.FP);
        putDef(ret, "#2R;277;nothing has been returned here", FP.FP);
        putDef(ret, "#2R;280;nothing has been returned here", FP.FP);
        putDef(ret, "#2R;283;nothing has been returned here", FP.FP);
        putDef(ret, "#2R;286;ColomnMoved should return ExtendedAttribute", FP.FP);
        putDef(ret, "#1R;588;this method is defined in the program", FP.FP);
        putDef(ret, "#2R;279;we can provide else block there in stead of if", FP.FP);
        putDef(ret, "#2R;276;all if statements uses just return", FP.FP);
        putDef(ret, "#1R;581;Instead of unnecessary casting you can write protected method and return same", FP.FP);
        putDef(ret, "#2R;275;no need to add any code in model", FP.FP);
        putDef(ret, "#1R;588;this method is not defined in class", FP.FP);
        putDef(ret, "#2R;279;we can use else if loop here", FP.FP);
        putDef(ret, "#2R;282;we can put this code into else", FP.FP);
        putDef(ret, "#0R;68;making false to true make changes in Re-ordering of header on UI", FP.FP);
        putDef(ret, "#1R;580;columnMoved method should be preoperly use to get the benefit of inheritance concept", FP.FP);
        putDef(ret, "#2R;275;method should not be protected due to basic rule of inheritance of protected", FP.FP);
        putDef(ret, "#2R;277;return type should not be there due to void", FP.FP);
        putDef(ret, "#1R;588;This method is not defind in this program", FP.FP);
        putDef(ret, "#2R;279;We can use here else condition after if", FP.FP);
        putDef(ret, "#2R;282;We can put this code in else condition", FP.FP);
        putDef(ret, "#1R;582;columnMoved(e.getFromIndex(), e.getToIndex())", WU.FROM_TO_SWAP);
        putDef(ret, "#0R;64;FileCellRenderer renderer = new FileCellRenderer();", FP.FP);
        putDef(ret, "#0R;65;browserView.setDefaultRenderer(Entry.class, renderer);", FP.FP);
        putDef(ret, "#1R;581;((VFSDirectoryEntryTableModel)getModel()).columnMoved( e.getFromIndex(),e.getToIndex());", WU.FROM_TO_SWAP);


        putDef(ret, "#1R;576;this.e = e", FP.FP);
        putDef(ret, "#0R;68;Correct", FP.FP);
        putDef(ret, "#1R;582;it  should be e.getFromIndex(), e.getToIndex());", WU.FROM_TO_SWAP);
        putDef(ret, "#2R;282;if (to<1 || to<=getColumnCount(){", FP.FP);
        putDef(ret, "#2R;284;if (to<from){return;}", FP.FP);
        putDef(ret, "#2R;279;instead of taking seperate if condition we cn take else block to meet the requirment", FP.FP);
        putDef(ret, "#0L;61;allow grid view in file system browser. we can pass parameter as true in setShowGrid.", FP.FP);
        putDef(ret, "#0L;78;we can set AUTO_RESIZE_ON as default , using this predefined variable we not need to resize manually.", FP.FP);
        putDef(ret, "#1L;576;we will store column count in on variable / we can use getColumnCount method than add 1 number / or we can apply increment on \"to\" variable. as \"to\" variable have max column count .", FP.FP);
        putDef(ret, "#1L;578;we can remove one column using getColumnCount() like we can subtract 1 no from  \"to\" variable. as \"to\" variable have max column count for table", FP.FP);
        putDef(ret, "#2R;279;conditions could be combined", FP.FP);
        putDef(ret, "#2R;282;to value should start from 2 and ends at getcolumnCount(). So = should be removed from the condition.", WU.OFF_BY_ONE2);
        putDef(ret, "#1R;581;Arguments passed to columnMoved method are mismatched with the method signature. Hence it may lead to inconsistent output.", WU.FROM_TO_SWAP);
        putDef(ret, "#0L;68;that is correct", FP.FP);
        putDef(ret, "#1L;580;its  correct", FP.FP);
        putDef(ret, "#0L;68;make this true", FP.FP);
        putDef(ret, "#1L;580;get index", FP.FP);
        putDef(ret, "#0R;68;Header object is not able to recognized", FP.FP);
        putDef(ret, "#2R;279;We can use else block instead of if block", FP.FP);
        putDef(ret, "#0R;58;the browserView is not the correct argument of this constructor as this is not used after initialize", FP.FP);
        putDef(ret, "#0R;59;Super() is used for calling parent constructor only.", FP.FP);
        putDef(ret, "#0R;62;if this class has the purpose to protect the data then all methods are should declare in Abstarct class and this constructor should not have all funcationality , Constructor only used for initialize the variables and obj creation. and method body should be declare in implemented class for secure purpose.", FP.FP);
        putDef(ret, "#1R;581;Here need to inter changed the parameter for columnMoved(from,to) method based on method body and its declaration. 2. Here need to create a object of VFSDirectoryEntryTableModel to call getModel() because this is getter method and this cant be called via use of classtype.", WU.FROM_TO_SWAP);
        putDef(ret, "#2R;277;1. method has return type void then if condition can't return. for this we can throw approperiate error-message/exception.", FP.FP);
        putDef(ret, "#2R;279;please don't use {..} for single line if condition", FP.FP);
        putDef(ret, "#2R;282;we can use all if condition in a single if condition, its better with less line of code", FP.FP);

        putDef(ret, "#1R;581;Here need to inter changed the parameter for columnMoved(from,to) method based on method body and its declaration.", WU.FROM_TO_SWAP);
        putDef(ret, "#1R;574;must overrride methods from implemented interface or must be marker or have some default method", FP.FP);
        putDef(ret, "#1R;576;Need statements", FP.FP);
        putDef(ret, "#1R;578;Need statements", FP.FP);
        putDef(ret, "#1R;581;should check with syntax to call method", WU.FROM_TO_SWAP);
        putDef(ret, "#1R;585;Need statements", FP.FP);
        putDef(ret, "#1R;587;No need to pass argument not using it", FP.FP);
        putDef(ret, "#2R;275;No Exception handled here", FP.FP);
        putDef(ret, "#2R;282;we can check all statement in one condition", FP.FP);
        putDef(ret, "#0R;68;.", FP.FP);
        putDef(ret, "#1R;581;para constructor", FP.FP);
        putDef(ret, "#2R;281;no Idea", FP.FP);
        putDef(ret, "#0R;68;add line", FP.FP);
        putDef(ret, "#1R;580;changes in code", FP.FP);
        putDef(ret, "#2R;279;add new code", FP.FP);
        putDef(ret, "#1R;580;this method is never used", FP.FP);

        /*
        E - second 30 developers
         */

        putDef(ret, "#1R;582;argument sequnce is incorrect. It should pass from index as first argument then to index as second argument in columnMoved method", WU.FROM_TO_SWAP);
        putDef(ret, "#0R;68;No changes required", FP.FP);
        putDef(ret, "#1R;582;Argument order should be e.getFromIndex(), e.getToIndex()", WU.FROM_TO_SWAP);
        putDef(ret, "#2R;282;we can take else block to provide alternate solution instead of checking condition", FP.FP);
        putDef(ret, "#0R;68;no changes is required", FP.FP);
        putDef(ret, "#2R;282;we can write else block to provide alternative solution instead of checking condition", FP.FP);
        putDef(ret, "#2R;282;We can take else block to provide alternate solution instead of checking condition.", FP.FP);
        putDef(ret, "#0L;68;Removed ordering of table heder data", FP.FP);
        putDef(ret, "#0R;68;Ordering the table header data is set to true", FP.FP);
        putDef(ret, "#1L;580;Logical implementation to re-order is not implemented", FP.FP);
        putDef(ret, "#1R;580;Implemented the logic to reorder the table information", FP.FP);
        putDef(ret, "#1R;581;calling the columnMoved(int,int) method to re arrange th etable headers.Arguments parsed are misplaced", WU.FROM_TO_SWAP);
        putDef(ret, "#2R;275;Actual logic implementation method to re- arrange the table headers", FP.FP);
        putDef(ret, "#0R;68;Ordering the header data is set to true", FP.FP);
        putDef(ret, "#1R;581;calling the columnMoved(int,int) method to re arrange th etable headers", FP.FP);
        putDef(ret, "#1R;581;e.getFromIndex() comes as 1st argument and e.getToIndex() as 2nd argument - Ex: ((VFSDirectoryEntryTableModel)getModel()).columnMoved(e.getFromIndex(),e.getToIndex());", WU.FROM_TO_SWAP);
        putDef(ret, "#1R;582;cast method parameter with (int)", FP.FP);
        putDef(ret, "#2R;276;use from.intValue() == to.intValue()", FP.FP);
        putDef(ret, "#2R;279;from.intValue()", FP.FP);
        putDef(ret, "#2R;282;to.intValue()", FP.FP);
        putDef(ret, "#0R;63;browserBiew.setIntercellSpacing(new Dimension(0,0));", FP.FP);
        putDef(ret, "#2R;286;extAttrs.add(extendedAttr,to - 1);", FP.FP);
        putDef(ret, "#0R;68;Line allows columns to get rearranged", FP.FP);
        putDef(ret, "#0R;64;this is not required", FP.FP);
        putDef(ret, "#2R;276;single if required if (from != lastFrom || to != lastTo)", FP.FP);
        putDef(ret, "#2R;275;change variables int from to int to and vice versa", FROM_TO_SWAP);
        putDef(ret, "#2R;279;Use else- if instead of if", FP.FP);
        putDef(ret, "#2R;282;use else-if instead of if", FP.FP);
        putDef(ret, "#0R;68;no change required", FP.FP);
        putDef(ret, "#1R;581;columoved method armensare not propery defined", FROM_TO_SWAP);
        putDef(ret, "#1R;581;Arguments mentioned in the method are interchanged", FROM_TO_SWAP);
        putDef(ret, "#1R;582;As per method structure columnMoved method should be - columnMoved(e.getFromIndex(), e.getToIndex())", FROM_TO_SWAP);
        putDef(ret, "#0R;68;for the header some Re-ordering is now true so we can arrange the element in re-order", FP.FP);
        putDef(ret, "#1R;580;This method is used to moved the cloumn from some index using class  VFSDirectoryEntryTableModel", FP.FP);
        putDef(ret, "#2R;275;A protected method od Sub class can't be access from outisde the package", FP.FP);
        putDef(ret, "#2R;276;Return type of this method is not supposed to use void check the logic to move index from and to it should be greater than 1 or total count of column .", FP.FP);
        putDef(ret, "#2R;276;we can use all conditions in one if. Because they all are return same.", FP.FP);
        putDef(ret, "#2R;276;we can use all conditions in one if. Because they all are return same. on line 276 is unneccessary condition.", FP.FP);
        putDef(ret, "#2R;275;veribles name shouble be like int to, int from", FROM_TO_SWAP);
        putDef(ret, "#2R;276;not need to check", FP.FP);
        putDef(ret, "#2R;279;not need to check", FP.FP);
        putDef(ret, "#2R;282;need only signle if  with condition from and to not equal and from and to less than getCoumnCount.", FP.FP);

 /*
        P - second 30 developers
         */

        putDef(ret, "#2R;275;Void type method must not return anything. and you can give one if condition(from != to, from and to > 1 ) instead of checking multiple condition", FP.FP);
        putDef(ret, "#1R;580;No check", FP.FP);
        putDef(ret, "#1R;581;getModel() method missing", FP.FP);
        putDef(ret, "#1R;582;No mismatch in the argument to is pass for from and vise versa", FROM_TO_SWAP);
        putDef(ret, "#2R;276;single statement no need of brackets", FP.FP);
        putDef(ret, "#2R;279;single statement no need of brackets Also there should only greater than sign, because in current context it will miss out on the last column", WU.OFF_BY_ONE1);
        putDef(ret, "#2R;282;single statement no need of brackets Also there should only greater than sign, because in current context it will miss out on the last column", WU.OFF_BY_ONE2);
        putDef(ret, "#2R;285;extAttrs variable initialization not found/missing", FP.FP);
        putDef(ret, "#2R;286;extAttrs variable missing", FP.FP);
        putDef(ret, "#1R;582;e.getFromIndex(),e.getToIndex());", FROM_TO_SWAP);
        putDef(ret, "#2L;275;return statement not allowed for void method", FP.FP);
        putDef(ret, "#1R;582;first and second argument should be interchange", FROM_TO_SWAP);
        putDef(ret, "#0R;68;Line Added for rearranged columns", FP.FP);
        putDef(ret, "#1R;580;Column Move method implementation added", FP.FP);
        putDef(ret, "#2R;275;New Method added for Column Move", FP.FP);
        putDef(ret, "#0R;68;enabled reordering", FP.FP);
        putDef(ret, "#1R;580;implemented columMove based on evenbt", FP.FP);
        putDef(ret, "#2R;275;added columMoved functionality to VFSDirectoryEntryTableModel", FP.FP);
        putDef(ret, "#2R;277;here we have not written any code to move columns we have just written return statement , but actually not returning anything", FP.FP);
        putDef(ret, "#2R;280;here we have not written any code to move columns we have just written return statement , but actually not returning anything", FP.FP);
        putDef(ret, "#2R;283;here we have not written any code to move columns we have just written return statement , but actually not returning anything", FP.FP);
        putDef(ret, "#1R;577;The class ColumnHandler implemented TableColumnModelListener interface so we need to  override all the method.", FP.FP);
        putDef(ret, "#2R;277;we can combined all three if block itno single if block.", FP.FP);
        putDef(ret, "#1R;574;method should be overide", FP.FP);
        putDef(ret, "#1R;580;method need ovrride all method", FP.FP);
        putDef(ret, "#2R;275;we can combine all condtion block to singl eblock", FP.FP);
        putDef(ret, "#1R;574;Method must override from Interface", FP.FP);
        putDef(ret, "#2R;275;no need to write multiple if  blocks", FP.FP);
        putDef(ret, "#1R;574;method should be override from interfaces or TableColumnModelListener must be  marker interface", FP.FP);
        putDef(ret, "#2R;275;better to use switch statement in this case  or single if block", FP.FP);
        putDef(ret, "#2R;276;we can achieve this with single if because return of all the if statement is same", FP.FP);

        return ret;
    }
}