package de.unihannover.orderingExperimentUi;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStream;
import java.io.File;

public class DataLog {

    private static final Object LOCK = new Object();
    private static OutputStream stream;

    public static void log(long experimentId, String message) {
        try {
            final long time = System.currentTimeMillis();
            final String fullString = experimentId + ";" + time + ";" + message.replace('\n', ' ').replace('\r', ' ') + "\n";
            final byte[] msg = fullString.getBytes("UTF-8");
            synchronized (LOCK) {
                if (stream == null) {
                    File file = new File ("log/experiment" + time + ".log");
	                stream = new FileOutputStream(file);
                }
                stream.write(msg);
                stream.flush();
            }
        } catch (final IOException e) {
            throw new RuntimeException("logging failed", e);
        }
    }

    public static void close() throws IOException {
        synchronized (LOCK) {
            if (stream != null) {
                stream.close();
            }
        }
    }

}
