package de.unihannover.orderingExperimentUi;

import java.util.Arrays;
import java.util.Collections;
import java.util.List;
import java.util.Random;

/**
 * Guidance approaches - different treatments given to participants.
 * Options are: - control = no guidance
 *              - checklist = checklist
 *              - strategy = strategy
 */

public enum GuidanceApproach {
    CONTROL,
    CHECKLIST,
    STRATEGY;

    private static final List<GuidanceApproach> VALUES =
            Collections.unmodifiableList(Arrays.asList(values()));
    private static final int SIZE = VALUES.size();
    private static final Random RANDOM = new Random();

    public static synchronized GuidanceApproach randomGuidanceApproach()  {
        return VALUES.get(RANDOM.nextInt(SIZE));
    }

}
